### Hi, 👋 I'm Adam

---

Hi there, I'm Adam 👋
🚀 Senior Full-Stack Programmer | Back-End & Infrastructure Specialist
With a background in electronic/mechanical systems, I've evolved into an experienced full-stack developer with a passion for back-end architecture and infrastructure. I specialize in building robust, scalable systems and optimizing deployment pipelines.

💻 Tech Stack

Languages: Go, JavaScript/TypeScript, Scala, Python  
Back-End: Node.js, Express, Deno, AWS Lambda  
Infrastructure: Docker, AWS, CI/CD pipelines  
Databases: MySQL, PostGIS, NoSQL solutions  
Front-End: Angular, React, HTML/CSS  

🔍 Current Focus

Developing scalable microservices with Go
Implementing infrastructure as code
Optimizing containerized environments
Exploring advanced database architectures
Building efficient CI/CD pipelines

🌱 Always Learning

Continuously deepening my understanding of distributed systems, cloud architecture, and computer science fundamentals. Currently exploring advanced Go patterns and Kubernetes orchestration.

🏗️ Featured Projects

Custom Golang backend with Docker deployment for my task management application
Database analysis tools for structural consistency
Geospatial visualization solutions

🤝 Connect & Collaborate

I'm always open to collaborating on interesting projects or discussing tech innovations. Feel free to reach out for feedback exchanges or potential collaborations!
Let's architect some amazing systems! 🛠️

---

Fun skill icons

[![My Skills](https://skillicons.dev/icons?i=js,html,css,sass)](https://skillicons.dev)
[![My Skills](https://skillicons.dev/icons?i=angular,typescript,nextjs,react,bootstrap,jquery)](https://skillicons.dev)
[![My Skills](https://skillicons.dev/icons?i=webpack,github,git,jest)](https://skillicons.dev)
[![My Skills](https://skillicons.dev/icons?i=arduino,cpp,scala,rust)](https://skillicons.dev)

[![Adam's GitHub trophys](https://github-profile-trophy.vercel.app/?username=am1macdonald&theme=tokyonight)](https://github.com/am1macdonald/github-readme-stats)

[![Adam's GitHub stats](https://github-readme-stats.vercel.app/api?username=am1macdonald)](https://github.com/am1macdonald/github-readme-stats)
---

Currently Working on...

Gridaxis - Geospatial Saas providing geocoding services throught a rest API   
TorontoWild - A community driven app for tracking wildlife sightings in Toronto
